﻿<cfsilent>
<cfparam name="attributes.expression" type="string" default="">
<cfif ThisTag.ExecutionMode EQ "Start">
	<cfset caseNum = 0>
	<cfset caseValue = attributes.expression>
	<cfset aExecutions = ArrayNew(1)>
</cfif>
<cfif ThisTag.ExecutionMode EQ "End">
	<cfif NOT ( caseNum OR Len(caseValue) )>
		<!---
		Create an array for weighted random selection.
		This has one entry case per unit of weight
		--->
		<cfset aWeightedCases = ArrayNew(1)>
		<cfloop index="ii" from="1" to="#ArrayLen(ThisTag.aCases)#">
			<cfloop index="jj" from="1" to="#ThisTag.aCases[ii].weight#">
				<cfset ArrayAppend(aWeightedCases,ThisTag.aCases[ii])>
				<cfset aWeightedCases[ArrayLen(aWeightedCases)]["num"] = ii>
			</cfloop>
		</cfloop>
		<!--- Pick from weighted array. --->
		<cfset pick = aWeightedCases[RandRange(1,ArrayLen(aWeightedCases))]["num"]>
		<!--- Expressions are safer, so we will use that if available. If not, then we will use the ordinality of the case --->
		<cfif Len(ThisTag.aCases[pick].value)>
			<cfset caseValue = ListFirst(ThisTag.aCases[pick].value,ThisTag.aCases[pick].delimiters)>
		<cfelse>
			<cfset caseNum = pick>
		</cfif>
		<!--- Make sure to empty the cases out before starting over --->
		<cfset ThisTag.aCases = ArrayNew(1)>
		<cfexit method="loop">
	<cfelseif ArrayLen(aExecutions)>
		<!--- Get the first case and the pop it out of the stack. This looping could go on for a while. --->
		<cfset caseValue = aExecutions[1]>
		<cfset ArrayDeleteAt(aExecutions,1)>
		<!--- Make sure to empty the cases out before starting over --->
		<cfset ThisTag.aCases = ArrayNew(1)>
		<cfexit method="loop">
	</cfif>
</cfif>
</cfsilent>